CREATE TABLE `chat_msg` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `from` bigint(20) unsigned NOT NULL default '0',
  `to` bigint(20) unsigned NOT NULL default '0',
  `born` timestamp NULL default '0000-00-00 00:00:00',
  `msg` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `to` (`to`),
  KEY `from` (`from`),
  KEY `born` (`born`)
);

CREATE TABLE `chat_pchat` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `msg` bigint(20) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `msg` (`msg`)
);

CREATE TABLE `chat_pvchat` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `msg` bigint(20) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `msg` (`msg`)
);

CREATE TABLE `chat_users` (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `nick` varchar(30) NOT NULL,
  `session` varchar(40) NOT NULL,
  `ip` varchar(15) NOT NULL default '000.000.000.000',
  `ping` timestamp NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `session` (`session`),
  UNIQUE KEY `nick` (`nick`),
  KEY `ping` (`ping`)
);

ALTER TABLE `chat_msg`
  ADD CONSTRAINT `chat_msg_ibfk_1` FOREIGN KEY (`from`) REFERENCES `chat_users` (`id`) ON DELETE CASCADE;

ALTER TABLE `chat_pchat`
  ADD CONSTRAINT `chat_pchat_ibfk_1` FOREIGN KEY (`msg`) REFERENCES `chat_msg` (`id`) ON DELETE CASCADE;

ALTER TABLE `chat_pvchat`
  ADD CONSTRAINT `chat_pvchat_ibfk_1` FOREIGN KEY (`msg`) REFERENCES `chat_msg` (`id`) ON DELETE CASCADE;
