<?php

// EasyPhpAlbum - a single script thumbnail gallary with navigation
// Copyright (C) 2004  JF Nutbroek - jfnutbroek@hotmail.com
//
// Version 1.1.1
// Requires PHP4.0.6+ and GDlib1.6+ - Tested with Linux and Windows
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
// GNU General Public License for more details. 
//
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
//
// How to use EasyPhpAlbum:
//
// Include this index.php file in your directory with JPG or PNG images - thats all!
// For multiple albums, create subdirectories and include the index.php script in each subdirectory
//
// htdocs/wwwroot						- Main directory for your albums
//		 - index.php					- This index.php script
//		 - Vacation Holland 2003			- Directory name of your first album
//		 	- index.php				- This index.php script
//			- This is Amsterdam.jpg			- The 1st image of this album
//			- This is Schiphol.jpg			- The 2nd image of this album
//		 - Vacation Holland 2002			- Directory name of your 2nd album
//			- index.php				- This index.php script
//			- Me in Amsterdam.jpg			- The 1st image of this album 
//			- Me in the Rijksmuseum.png		- The 2nd image of this album
//
// If you would like to have a specific order for albums or photos start directory & filenames with 001, 002, 003 etc.
// Example directory names: '001 Vacation Holland 2003' and '002 Vacation Holland 2002' etc.
// Example file names: '001 This is Amsterdam.jpg' and '002 This is Schiphol.jpg' etc.
// If your server does not accept spaces in directory or file names use the underscore '_', it will be replaced by a space

// Configuration

$gd2=true;						// Set to true if your server has GDLib2+ (for better quality thumbnails)
$title='Photo Albums';					// Page title - leave empty to display directory name
$images_per_page=6;					// Number of photos to display per page
$columns_per_page=3;					// Number of photos next to each other
$thumb_size=160;					// Size in px for thumbnails (min. 30 pixels)
$show_name=true;					// Display file name: true or false (tip: use filename as short description for photo)
$show_details=true;					// Display photo dimensions & filesize: true or false
$show_date=false;					// Display file date: true or false
$show_number=false;					// Display photo number in thumbnail: true or false
$show_binder=false;					// Display binder: true or false
$binder_spacing=8;					// Space between binder-rings in px
$border_width=10;					// Add border around photo - width in px (0=no border)
$show_bordershadow=true;				// Display shadow around border: true or false
$home_page='';						// An absolute link to your home page - leave empty to exclude
$language_page='Page';					// Text for page number - Change this in your own language
$language_homepage='Home';				// Menu text for home page - change this in your own language
$language_albums='Albums';				// Text for amount of albums - change this in your own language
$language_photos='Photos';				// Text for amount of photos - change this in your own language
$language_view='View';					// Text for tooltip - change this in your own language
$page_color='#ffffff';					// Page background color
$text_color='#000000';					// Text color
$text_hover_color='#ff0000';				// Text hover color
$title_color='#000000';					// Title color
$border_color='#ffffff';				// Photo background color
$table_color='#ffffff';					// Table backgound color
$item_border_color='#ffffff';				// Border color
$line_color='#000000';					// Color for lines
$menu_border_color='#000000';				// Menu Border color
$menu_text_color='#000000';				// Menu text color
$menu_hover_color='#00000';				// Menu hover color applies to text and bar
$menu_bar_color='#000000';				// Menu bar color
$menu_background_color='#ffffff';			// Menu background color
$menu_background_hover_color='#cccccc';			// Menu background hover color

// End Configuration

// Create and output thumbnail
if (isset($_REQUEST['image'])) {
	$image=$_REQUEST['image'];
	$image=str_replace(chr(92),chr(47),getcwd()).'/'.$image;
	if (file_exists($image)) {
		$size=@GetImageSize($image);
		if ($size[2]==2)
	    		$im=@imagecreatefromjpeg($image);
		if ($size[2]==3)
			$im=@imagecreatefrompng($image);
		if ($size[2]!=2 && $size[2]!=3) {
			$thumb=invalid_image();
		} else {
			if ($thumb_size<30)
				$thumb_size=30;
			if ($show_binder)
				$border_offset=3;
			else
				$border_offset=2;
			if ($gd2) {
				if ($size[0]>$size[1])
					$thumb=imagecreatetruecolor($border_width*$border_offset+$thumb_size,$border_width*2+ceil($size[1]/($size[0]/$thumb_size)));
				else
					$thumb=imagecreatetruecolor($border_width*$border_offset+ceil($size[0]/($size[1]/$thumb_size)),$border_width*2+$thumb_size);
			} else {
				if ($size[0]>$size[1])
					$thumb=imagecreate($border_width*$border_offset+$thumb_size,$border_width*2+ceil($size[1]/($size[0]/$thumb_size)));
				else
					$thumb=imagecreate($border_width*$border_offset+ceil($size[0]/($size[1]/$thumb_size)),$border_width*2+$thumb_size);
			}
			$black=imagecolorallocate($thumb,0,0,0);
			$white=imagecolorallocate($thumb,255,255,255);
			$gray=imagecolorallocate($thumb,192,192,192);
			$middlegray=imagecolorallocate($thumb,158,158,158);
			$darkgray=imagecolorallocate($thumb,128,128,128);
			imagefill($thumb,0,0,imagecolorallocate($thumb,hexdec(substr($border_color,1,2)),hexdec(substr($border_color,3,2)),hexdec(substr($border_color,5,2))));
			if ($show_binder)
				$bind_offset=4;
			else
				$bind_offset=0;
			if ($show_bordershadow) {
				imagerectangle($thumb,$bind_offset,0,imagesx($thumb)-4,imagesy($thumb)-4,$gray);
				imageline($thumb,$bind_offset+2,imagesy($thumb)-3,imagesx($thumb),imagesy($thumb)-3,$darkgray);
				imageline($thumb,imagesx($thumb)-3,2,imagesx($thumb)-3,imagesy($thumb),$darkgray);
				imageline($thumb,$bind_offset+2,imagesy($thumb)-2,imagesx($thumb),imagesy($thumb)-2,$middlegray);
				imageline($thumb,imagesx($thumb)-2,2,imagesx($thumb)-2,imagesy($thumb),$middlegray);
				imageline($thumb,$bind_offset+2,imagesy($thumb)-1,imagesx($thumb),imagesy($thumb)-1,$gray);
				imageline($thumb,imagesx($thumb)-1,2,imagesx($thumb)-1,imagesy($thumb),$gray);
			}
			if ($gd2)
				imagecopyresampled($thumb,$im,$border_width*($border_offset-1),$border_width,0,0,imagesx($thumb)-($border_offset*$border_width),imagesy($thumb)-2*$border_width,imagesx($im),imagesy($im));
			else
				imagecopyresized($thumb,$im,$border_width*($border_offset-1),$border_width,0,0,imagesx($thumb)-($border_offset*$border_width),imagesy($thumb)-2*$border_width,imagesx($im),imagesy($im));
			if ($show_number && isset($_REQUEST['number']) && isset($_REQUEST['total'])) {
				$colors=array();
				for ($i=5;$i<25;$i++) {
					$indexis=ImageColorAt($thumb,$i,4+ceil($i/5));
					$rgbarray=ImageColorsForIndex($thumb,$indexis);
					array_push($colors,$rgbarray['red'],$rgbarray['green'],$rgbarray['blue']);
				}
				if (array_sum($colors)/count($colors)>180)
					$textcolor=imagecolorallocate($thumb,0,0,0);
				else
					$textcolor=imagecolorallocate($thumb,255,255,255);
				if ($show_binder)
					$number_offset=$border_width*2;
				else
					$number_offset=$border_width;
				if ($border_width==0)
					$number_offset=1;
				imagestring($thumb,1,$number_offset,1,($_REQUEST['number']+1) . '/' . $_REQUEST['total'],$textcolor);
			}
			if ($show_binder) {
				$spacing=floor(imagesy($thumb)/$binder_spacing)-2;
				$offset=floor((imagesy($thumb)-($spacing*$binder_spacing))/2);
				for ($i=$offset;$i<=$offset+$spacing*$binder_spacing;$i+=$binder_spacing) {
					imagefilledrectangle($thumb,8,$i-2,10,$i+2,$black);
					imageline($thumb,11,$i-1,11,$i+1,$darkgray);
					imageline($thumb,8,$i-2,10,$i-2,$darkgray);
					imageline($thumb,8,$i+2,10,$i+2,$darkgray);
					imagefilledrectangle($thumb,0,$i-1,8,$i+1,$gray);
					imageline($thumb,0,$i,8,$i,$white);
					imageline($thumb,0,$i-1,0,$i+1,$gray);
					imagesetpixel($thumb,0,$i,$darkgray);
				}
			}
		}
		if ($size[2]==2) {
			header("Content-type: image/jpeg");
			imagejpeg($thumb,'',90);
		} else {
			header("Content-type: image/png");
			imagepng($thumb);
		}
	} else {
		$thumb=invalid_image();
		header("Content-type: image/png");
		imagepng($thumb);
	}
	imagedestroy($im);
	imagedestroy($thumb);
	exit;
}

// Detect sub directories - if present; current index.php file is home - otherwise detect directories one level higher
$dir_names=array();
$file_names=array();
$album_show=false;
$total_amount_images=0;
if ($dir=@opendir(getcwd())) {
	while ($file=readdir($dir)) {
		if (($file!='.') && ($file!='..') && is_dir($file) && file_exists($file.'/index.php')) {
			$images=get_images($file);
			if (count($images)!=0) {
				array_push($dir_names,$file);
				array_push($file_names,$file . '/' . $images[0]);
				$album_show=true;
				$total_amount_images=$total_amount_images+count($images);
			}
		}
	}
}
sort($dir_names);
sort($file_names);
$total_amount_albums=count($dir_names);
if (count($dir_names)==0) {
	$dir_names=array();
	if ($dir=@opendir('../')) {
		while ($file=readdir($dir)) {
			if (($file!='.') && ($file!='..') && is_dir('../'.$file) && file_exists('../'.$file.'/index.php') && $file!=substr(getcwd(),-strlen($file))) {
				$images=get_images('../' . $file);
				if (count($images)!=0)
					array_push($dir_names,'../' . $file);
			}
		}
	}
	sort($dir_names);
	$file_names=array();
	$file_names=get_images('./');
	sort($file_names);
}

// Page title
if ($title=='') {
	$title=str_replace(chr(92),chr(47),getcwd());
	$title=str_replace('_',' ',$title);
	$title=substr($title,strrpos($title,chr(47))+1);
	if (ereg("([0-9]{3})",substr($title,0,3)))
		$title=trim(substr($title,3));
}

// Evaluate which thumbnails to show on current page
$max_files=count($file_names);
if (isset($_REQUEST['page']))
 	$page=abs((int) $_REQUEST['page']);
else
	$page=0;
$albumpage=ceil($page/$images_per_page)+1;
$show_files=$page+$images_per_page;
if ($show_files>$max_files)
	$show_files=$max_files;
if ($page==$show_files)
	$page-=$images_per_page;

// Create HTML page
echo "<html><head><title>$title</title>\n";
echo "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"><meta http-equiv=\"content-style-type\" content=\"text/css\"><meta http-equiv=\"content-script-type\" content=\"text/javascript\">\n";
echo "</head><body marginwidth=\"0\" marginheight=\"0\" topmargin=\"0\" leftmargin=\"0\">\n";

// CSS Styles
html_w3C_css();

// Javascript for pop-up window
echo "<form name=\"browser\" method=\"POST\" action=\"index.php\" enctype=\"multipart/form-data\"><input type=\"hidden\" name=\"page\">\n";
echo "<script language=\"JavaScript\">\n";
echo "var popup=null;\n";
echo "function showpage(page) {\n"; 
echo "document.browser.page.value=page;\n";
echo "if (popup && popup.open) popup.close();\n";
echo "document.browser.submit();\n";
echo "}\n";
echo "function viewer(image,name,width,height) {\n"; 
echo "if (popup && popup.open) popup.close();\n";
echo "var poswx=(screen.width > width ? (screen.width - width)/2 : 0);\n";
echo "var poswy=(screen.height > height ? (screen.height - height)/3 : 0);\n";
echo "popup=window.open(\"\",\"popup\",\"width=\" + width + \",height=\" + height + \",status=no,resizable=no,scrollbars=no,top=\" + poswy + \",left=\" + poswx + \",dependent=yes,alwaysRaised=yes\");\n";
echo "popup.document.write(\"<html><head><title>\" + name + \"</title><meta http-equiv='content-type' content='text/html; charset=ISO-8859-1'><body marginwidth='0' marginheight='0' topmargin='0' leftmargin='0'>\");\n";
echo "popup.document.write(\"<img src='\" + image + \"' width='\" + width + \"' height='\" + height + \"' border='0'>\");\n";
echo "popup.document.write(\"</body></html>\");\n";
echo "popup.document.close();\n";
echo "popup.focus();\n";
echo "}\n";
echo "</script>\n";
echo "<div id=\"content\"><h1>$title</h1><div class=\"line\">&nbsp;</div><div id=\"leftmargin\">";
echo "<table class=\"tablesmaller\">\n";

// Display thumbnail images
$colcount=0;
for ($count=$page;$count<$show_files;$count++) {
	$file_size=floor(filesize($file_names[$count])/1024);
	$file_date=date('Y-m-d H:i',filemtime($file_names[$count]));
	$file_name=substr($file_names[$count],0,strpos($file_names[$count],'.'));
	if (ereg("([0-9]{3})",substr($file_name,0,3)))
		$file_name=trim(substr($file_name,3));
	if (strpos($file_name,'/')!=false) {
		$link=substr($file_names[$count],0,strpos($file_names[$count],'/'));
		$file_name=substr($file_name,0,strpos($file_name,'/'));
	}
	$size=@GetImageSize('./' . $file_names[$count]);
	$image_filename=rawurlencode($file_names[$count]);
	if (strpos($file_names[$count],'/')===false && $size[0])
		$content="<a href=\"#link\"><img src=\"index.php?image=$image_filename&number=$count&total=$max_files\" onclick=\"viewer('$file_names[$count]','$file_name',$size[0],$size[1])\" alt=\"$language_view\"></a><br>";
	else if ($size[0])
		$content="<a href=\"$link/index.php\"><img src=\"index.php?image=$image_filename&number=$count&total=$max_files\" alt=\"$language_view $file_name\"></a><br>";
	else
		$content="<img src=\"index.php?image=$image_filename&number=$count&total=$max_files\"><br>";
	if ($show_name==true)
		$content.=str_replace('_',' ',$file_name) . '<br>';
	if ($show_details==true)
		$content.=$size[1] . "x" . $size[0] . " / $file_size Kb<br>";
	if ($show_date==true)
		$content.="$file_date";
	if ($columns_per_page==1) {
		echo "<tr><td class=\"tablecell\">$content</td></tr>\n";
	} else {
		$colcount+=1;
		if ($colcount==1) {
			echo "<tr><td class=\"tablecell\">$content</td>\n";
		} else if ($colcount<$columns_per_page) {
			echo "<td class=\"tablecell\">$content</td>\n";
		} else {
			echo "<td class=\"tablecell\">$content</td></tr>\n";
			$colcount=0;
		}
	}
	if ($colcount<$columns_per_page && $colcount!=0 && $count==$show_files-1) {
		for ($emptycol=$colcount;$emptycol<$columns_per_page;$emptycol++)
			echo "<td>&nbsp;</td>";
		echo "</tr>\n";
	}
}

echo "<tr><td colspan=\"$columns_per_page\" nowrap=\"nowrap\">&nbsp;</td></tr>\n";

// Page numbers
if ($max_files>$images_per_page) {
	if ($albumpage==1)
		echo "<tr><td nowrap=\"nowrap\" colspan=\"$columns_per_page\">$language_page <a href=\"#link\" onclick=\"showpage(0)\"><u>1</u></a>";
	else
		echo "<tr><td nowrap=\"nowrap\" colspan=\"$columns_per_page\">$language_page <a href=\"#link\" onclick=\"showpage(0)\">1</a>";
	for ($i=$images_per_page;$i<count($file_names);$i+=$images_per_page) {
		$p=ceil($i/$images_per_page)+1;
		if ($albumpage==$p)
			echo " | <a href=\"#link\" onclick=\"showpage($i)\"><u>$p</u></a>";
		else
			echo " | <a href=\"#link\" onclick=\"showpage($i)\">$p</a>";
	}
	echo "</td></tr>\n";
}

echo "</table></div><div class=\"line\">&nbsp;</div>";

// Bottom menu
if ($home_page!='')
	echo "<div id=\"bottommenu\"><a href=\"$home_page\">$language_homepage</a></div>";
if ($total_amount_albums!=0)
	echo "<div id=\"bottominfo\">$language_albums: $total_amount_albums | $language_photos: $total_amount_images</div>";
if (!$album_show) {
	for ($count=0;$count<count($dir_names);$count++) {
		$dir_name=$dir_names[$count];
		if (strpos($dir_names[$count],'/')!=false)
			$dir_name=substr($dir_names[$count],3);
		if (ereg("([0-9]{3})",substr($dir_name,0,3)))
			$dir_name=trim(substr($dir_name,3));
		$dir_name=str_replace('_',' ',$dir_name);
		echo "<div id=\"bottommenu\"><a href=\"$dir_names[$count]/index.php\">$dir_name</a></div>";
	}
}

echo "</div></form></body></html>\n";

// Functions

// Create error image
function invalid_image() {
	$im=imagecreate(75,75);
	$black=imagecolorallocate($im,0,0,0);
	$yellow=imagecolorallocate($im,255,255,0);
	imagefilledrectangle($im,0,0,75,75,imagecolorallocate($im,255,0,0));
	imagerectangle($im,0,0,74,74,$black);
	imageline($im,0,20,75,20,$black);
	imagefilledrectangle($im,1,1,73,19,$yellow);
	imagefilledrectangle($im,25,35,50,60,$yellow);
	imagerectangle($im,24,34,51,61,$black);
	imageline($im,25,35,50,60,$black);
	imageline($im,50,35,25,60,$black);
	imagestring($im,1,5,5,'Invalid Image',$black);
	return $im;
}

// Read all JPG,PNG files in directory
function get_images($location) {
	$file_names=array();
	if ($dir=@opendir("$location/")) {
		while ($file=readdir($dir)) {
			if (($file!='.') && ($file!='..') && !is_dir($file)) {
				$extension=ltrim(strtolower(substr($file,-4)),'.');
				if ($extension=='jpg' || $extension=='jpeg' || $extension=='png') {
					array_push($file_names,$file);
				}
			} 
		}
	}
	sort($file_names);
	return($file_names);
}

// W3C validated CSS code
function html_w3c_css() {
	global $border_color,$table_color,$text_color,$page_color,$title_color,$text_hover_color;
	global $menu_hover_color,$menu_background_color,$menu_text_color,$menu_background_hover_color;
	global $line_color,$item_border_color,$menu_bar_color,$menu_border_color;
	echo "<style type=\"text/css\">\n";
	echo "body {\n";
	echo "	background-color : $page_color;\n";
	echo "	font-size : 76%;\n";
	echo "}\n";
	echo "h1 {\n";
	echo "	background-color : $page_color;\n";
	echo "	color : $title_color;\n";
	echo "	font-family : Arial, Helvetica, sans-serif;\n";
	echo "	padding : 0.5em 0 0 2%;\n";
	echo "	font-size : 1.8em;\n";
	echo "}\n";
	echo "a:link {\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	background-color : transparent;\n";
	echo "	color : $text_color;\n";
	echo "	text-decoration : none;\n";
	echo "}\n";
	echo "a:visited {\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	background-color : transparent;\n";
	echo "	color : $text_color;\n";
	echo "	text-decoration : none;\n";
	echo "}\n";
	echo "a:hover {\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	background-color : transparent;\n";
	echo "	color : $text_hover_color;\n";
	echo "	text-decoration : underline;\n";
	echo "}\n";
	echo "img {\n";
	echo "	border-width : 0px;\n";
	echo "	margin-bottom : 5px;\n";
	echo "}\n";
	echo ".tablesmaller {\n";
	echo "	margin : 1%;\n";
	echo "	width : 10%;\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	background-color : transparent;\n";
	echo "	color : $text_color;\n";
	echo "	font-size : 1em;\n";
	echo "	padding : 1em;\n";
	echo "}\n";
	echo ".tablecell {\n";
	echo "	border : 0.01em solid $item_border_color;\n";
	echo "	background-color : $table_color;\n";
	echo "	padding : 0.5em;\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	font-size : 1em;\n";
	echo "	text-align : center;\n";
	echo "	vertical-align : middle;\n";
	echo "}\n";
	echo ".line {\n";
	echo "	border-top : 0.01em solid $line_color;\n";
	echo "	border-bottom : medium none inherit;\n";
	echo "	margin : 0 0 0 2%;\n";
	echo "}\n";
	echo "#leftmargin {\n";
	echo "	margin-left : 20px;\n";
	echo "	text-align : center;\n";
	echo "}\n";
	echo "#content {\n";
	echo "	position : absolute;\n";
	echo "	left : 10px;\n";
	echo "	top : 20px;\n";
	echo "	width : 85%;\n";
	echo "	height : 100%;\n";
	echo "}\n";
	echo "#bottommenu {\n";
	echo "	display : inline;\n";
	echo "	margin-left : 20px;\n";
	echo "	margin-bottom : 10px;\n";
	echo "	border : 1px solid $menu_border_color;\n";
	echo "	width : 140px;\n";
	echo "	padding : 0em;\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	font-size : 0.9em;\n";
	echo "	background-color : $menu_background_color;\n";
	echo "	color : $menu_text_color;\n";
	echo "}\n";
	echo "#bottommenu a {\n";
	echo "	display : inline;\n";
	echo "	padding : 5px;\n";
	echo "	margin-top : 0;\n";
	echo "	border-left : 3px solid $menu_bar_color;\n";
	echo "	background-color : transparent;\n";
	echo "	text-decoration : none;\n";
	echo "	width : 100%;\n";
	echo "	font-size : 1em;\n";
	echo "	color : $menu_text_color;\n";
	echo "}\n";
	echo "#bottommenu a:hover {\n";
	echo "	border-left : 0.3em solid $menu_hover_color;\n";
	echo "	background-color : $menu_background_hover_color;\n";
	echo "	color : $menu_hover_color;\n";
	echo "}\n";
	echo "#bottominfo {\n";
	echo "	display : inline;\n";
	echo "	margin-left : 20px;\n";
	echo "	margin-bottom : 10px;\n";
	echo "	border : 1px solid $menu_border_color;\n";
	echo "	width : 140px;\n";
	echo "	padding : 5px;\n";
	echo "	font-family : Tahoma, Arial, Helvetica, sans-serif;\n";
	echo "	font-size : 0.9em;\n";
	echo "	background-color : $menu_background_color;\n";
	echo "	color : $menu_text_color;\n";
	echo "}\n";
	echo "</style>\n";
	return;
}

?>