<?php
   require_once("db.php");
   require_once("globals.php");
//      
//    "name" "id"  "idParent"
class Catalog {
  var $curr_level; //  
  var $curr_node;  //  
  var $table_name; // 
  var $db;         //      

//       
function Catalog ($table)
{
  global $host,$username,$password,$dbname;

  $this->curr_level = 0;
  $this->curr_node  = 0;
  $this->db = new DB($host,$username,$password,$dbname);
  $this->table_name = $table;
}

function get_parent($id)
{
  $row = $this->db->select("select idParent from $this->table_name
                            where id=$id");
  return $row->idParent;
}

function has_children($id)
{
  global $host,$username,$password,$dbname;
  $cdb =  new DB($host,$username,$password,$dbname);
  $row = $cdb->select("select count(1) as C from $this->table_name where idParent=$id");
  $cdb->close();
  return !empty($row->C) and $row->C > 0;
}

function change_node($id)
{
   $this->curr_node = $id;
}

//   ,   
function get_path($id)
{
   if ($id == 0) return '';
   $row = $this->db->select("select name,idParent from $this->table_name where id=$id ");
   $s = $row->name;
   while ($row->idParent > 0) {
     $row = $this->db->select("select name,idParent from $this->table_name where id=$row->idParent ");
     $s = "$row->name->".$s;
   }
   return $s;
}

//   .   
//   
//   
function print_node($id,$name)
{
  print "Abstract print_node:$id, $name<br>";
}
//   
function print_leaf($id,$name)
{
  print "Abstract print_leaf:$id, $name<br>";
}

//   ""
function print_up($id)
{
  print "Abstract print_up:$id<br>";
}

function list_level()
{
  if ($this->curr_node > 0) {
    $parent = $this->get_parent($this->curr_node);
     if (!empty($parent) or $parent == 0) $this->print_up($parent);
  }
  $row = $this->db->select("select name,id from $this->table_name
                            where idParent=$this->curr_node order by name");
  while (!$this->db->eof()) {
    if ($this->has_children($row->id))
      $this->print_node($row->id,$row->name);
    else
      $this->print_leaf($row->id,$row->name);
    $row = $this->db->next();
  }
}

}

//    
class Goods {
  var $db;
  var $table_name;
  var $catalog;

function Goods($table,$Catalog) {
  global $host,$username,$password,$dbname;
  $this->db = new DB($host,$username,$password,$dbname); ;
  $this->table_name = $table;
  $this->catalog = $Catalog;
}

function print_form_header()
{
  print "Abstract print_header";
}

function print_item($id,$name,$desc,$price)
{
  print "Abstract print_item $id,$name,$desc,$price";
}

function print_footer()
{
  print "Abstract print_footer";
}

function list_goods($id_type) {
  $this->print_form_header();
  $row = $this->db->select("select id,name,price,description
                            from Goods where idType=$id_type");
   while (!$this->db->eof()) {
    $this->print_item($row->id,$row->name,$row->description,$row->price);
    $row = $this->db->next();
  }
  $this->print_footer();
}

}


?>