<?php
include_once("include/general.php");
include_once("include/wiki.php");

function redirect($pagename, $time=3) {
?>
		<script language="JavaScript">
<!--
	function redirect()
	{
		window.location = "<?php echo "$pagename" ?>"
	}
	setTimeout("redirect();", <?php echo "$time" ?>)
// -->
		</script>
<?php
}

function recent_changes($num) // Contributed by Jose Nazario (jose@monkey.org)
{
	$files_directory = wikipage_root();
	$new_array = array();
	$files = array();
	$fdirectory = opendir( "$files_directory" );
	while ($file = readdir( $fdirectory ) ) {
		if ( ( $file == "." ) || ( $file == ".." ) || ereg('^\.', $file) ) {
		} else {
			array_push( $files, $file );
		}
	}
	foreach ( $files as $key=> $file ) {
		$c_date = filemtime("{$files_directory}$file");
		$new_array[$c_date] = $file;
	}
	krsort( $new_array );
	$j = 0;
	while (($this_array = each( $new_array))){
		$value = $this_array['value'];
		$key = $this_array['key'];
		$key_convert = date("M j, h:ia", $key);
		//echo "$value $key_convert <br>";
		$recentpages[] = $value;
		if ($j >= $num-1) break;
		$j++;
	}
	clearstatcache();
	return $recentpages;
}

function display_findresults($query) {
	$directory = opendir(wikipage_root());
	$filelist = array();
	$i=0;
	while ($file = readdir($directory)) {
		if ($file[0]!='.') {
			$filelist[$i]=$file;
			$i++;
		}
	}
	closedir($directory);
	foreach ($filelist as $value) {
		$filedata = text_from_wikipage($value);
		if (strstr($filedata, $query) !== FALSE) {
			echo '<a href="' . url_of_wikipage($value) . '">' . $value . '</a><br />';
		}
	}
}

function parse_file($path) {
	$file = fopen($path, "r");
	if (!$file) {
		return array();
	}
	while (!feof($file)) {
		$buffer = fgets($file, 1024);
		$comment = explode('#', $buffer);
		$sides = explode('=', $comment[0]);
		$data[trim($sides[0])] = trim($sides[1]);
	}
	return $data;
}

function get_pane_data($pane) {
	return parse_file('preferencepanes/' . $pane);
}

function display_prefpane($pane) {
	$panedata = get_pane_data($pane);
?>
	<div class="preferencepane">
	<div class="panelname"><?php echo $panedata['PanelName'] ?></div>
<?php
	if (isset($panedata['PanelDescription'])) {
		echo '<div class="paneldesc">' . $panedata['PanelDescription'] . '</div>';
	}
	echo '<div class="panelcontent"><form action="doprefs.php" method="post"><p>';
	if ($panedata['PanelType'] === 'SelectFileFromDirectory') {
		$dir = opendir($panedata['Directory']);
		while ($file = readdir($dir)) {
			if ($file[0] != '.') {
				echo '<label><input type="radio" name="value" value="' . $file . '" />' . $file . '</label> - ';
			}
		}	
		closedir($dir);
	}
	if ($panedata['PanelType'] === 'CheckBox') {
		echo '<label><input type="radio" name="value" value="1" />' . $panedata['CheckBox'] . '</label> <label><input type="radio" name="value" value="0" />' . $panedata['NegativeCheckBox'] . "</label>\n";
	}
	if ($panedata['PanelType'] === 'EnterText') {
?>
		<input type="text" name="value" class="textinput" />
<?php
	}
	if($panedata['Action'] === 'CreateCookie') {
		echo '<br /><br /><label><input type="radio" name="permanent" value="1" />Cookies are permanent</label> - <label><input checked="checked" type="radio" name="permanent" value="0" />Cookies expire when browser quits</label><br />';
	}
?>
		<input type="hidden" name="pane" value="<?php echo $pane ?>" />
		<input type="hidden" name="page" value="<?php echo $_GET['page'] ?>" />
		<input type="submit"<?php
	if (isset($panedata['SubmitButton'])) {
		echo ' value="' . $panedata['SubmitButton'] . '"';
	}
		?> class="submitbutton" /></p>
	</form>
	</div>
	</div>
<?php
	fclose($panefile);
}

function do_special($special_string) {
	$options = parse_file("options");
	if($special_string == "findresults") {
		display_findresults($_POST['query']);
	}
	if($special_string == "recentchanges") {
		$rcfile = fopen("recent_changes.txt","r");
		for ($i=0; !feof($rcfile); $i++) {
			$buffer[$i]=fgets($rcfile,1024);
		}
		for ($i=count($buffer)-2; $i >= 0; $i--) {
			$components = explode("~", $buffer[$i]);
			echo link_to_wikipage($components[0]) . " - {$components[1]} <br />\n";
		}
		fclose($rcfile);
	}
	if ($special_string == "preferences") {
		$dir = opendir("preferencepanes/");
		if ($dir !== FALSE) {
			while (FALSE !== $file = readdir($dir)) {
				if ($file[0]!='.') {
					display_prefpane($file);
				}
			}
			closedir($dir);
		}
	}
	if ($special_string == "random") {
		$pages = array();

		$wikipagedir = opendir(wikipage_root());
		while ($file = readdir($wikipagedir)) {
			if ($file[0] != '.') {
				$pages[] = $file;
			}
		}
		closedir($wikipagedir);
		$randompagename = $pages[array_rand($pages)];
		redirect(url_of_wikipage($randompagename));
		echo "Redirecting to " . link_to_wikipage($randompagename) . "...<br />\n";
	}
	if ($special_string == "sources") {
?>
	<a href="wiki.php?viewcode=wiki.php">wiki.php</a><br />
	<a href="wiki.php?viewcode=doprefs.php">doprefs.php</a><br />
	<a href="wiki.php?viewcode=post.php">post.php</a><br />
	<a href="wiki.php?viewcode=wiki2rss.php">wiki2rss.php</a><br />
	<a href="wiki.php?viewcode=include/wiki.php">include/wiki.php</a><br />
	<a href="wiki.php?viewcode=include/special.php">include/special.php</a><br />
	<a href="wiki.php?viewcode=include/general.php">include/general.php</a><br />
	<a href="wiki.php?viewcode=include/history.php">include/history.php</a><br />
	<a href="wiki.php?viewcode=include/setup.php">include/setup.php</a><br />
<?php
	}
	if ($special_string == "prune") {
		$wikipagedir = opendir(wikipage_root());
		while ($file = readdir($wikipagedir)) {
			if ($file[0] != '.') {
				if (strlen(text_from_wikipage($file))==0) {
					unlink(path_of_wikipage($file));
					echo $file . " empty, pruned...<br />\n";
				} else {
					foreach (backups_of_wikipage($file) as $date) {
					// 0-1 = day, 3-4 = month, 6-9 = year
					// 11-12 = hour, 14-15 = minute, 17-18 =second
						if (strlen(path_of_backuppage($file,$date)) ==0) {
							echo "Backup of $file at $date empty, pruned...";
						} else {
							$day = substr($date, 0, 2);
							$month = substr($date, 3, 2);
							$year = substr($date, 6, 4);
							$hour = substr($date, 11, 2);
							$minute = substr($date, 14, 2);
							$second = substr($date, 17, 2);
							$time = strtotime("$month/$day/$year $hour:$minute:$second");
							$maxtime = strtotime($options['BackupExpiration']);
							if ($maxtime == -1) {
								$maxtime = time() - 5184000;
							}
							if ($time < $maxtime) {
								unlink(path_of_backuppage($file,$date));
								echo "Backup on $date too old, pruned...<br />\n";
							}
						}
					}
				}
			}
		}
		closedir($wikipagedir);
		$rcfile = fopen("recent_changes.txt","r");
		for ($i=0; !feof($rcfile); $i++) {
			$buffer[$i]=fgets($rcfile,1024);
		}
		fclose($rcfile);
		for ($j=1; $j<$i; $j++) {
			if ($j >= $options['MaxRecentChanges']) {
				$components = explode("~",$buffer[($i-$j)-1]);
				echo "RecentChanges entry " . $components[0] . " on " . $components[1] . " pruned due to overflow...<br />\n";
				$buffer[($i-$j)-1] = "";
			}
		}
		$rcfile = fopen("recent_changes.txt","w");
		for ($i=0; $i<sizeof($buffer); $i++) {
			fputs($rcfile,$buffer[$i],strlen($buffer[$i]));
		}
		fclose($rcfile);
	}
}
?>
