<?php
include_once("include/general.php");
include_once("include/special.php");

function current_page() {
	if (isset($_GET['page'])) {
		return $_GET['page'];
	}
	if (isset($_POST['page'])) {
		return $_POST['page'];
	}
	return FALSE;
}

function wikipage_root() {
	$options = parse_file("options");
	return $options['WikiPageRoot'];
}

function path_of_backuppage($page, $date) {
	return wikipage_root() . ".$page.$date";
}

function print_diff_for_wikipage($page) {
	$backups = backups_of_wikipage($page);
	if (count($backups) == 0) { return 0; }
	echo "<pre>\n";
	passthru('diff ' . path_of_wikipage($page) . " " . path_of_backuppage($page,$backups[count($backups) - 1]));
	echo "</pre>\n";
}

function backups_of_wikipage($page) {
	$backups = NULL;
	$wikipages = opendir(wikipage_root());
	while ($file = readdir($wikipages)) {
		if ($file[0] == '.' && strstr($file, $page) !== FALSE) {
			$backups[] = substr($file, strlen($page) + 2);
		}
	}
	closedir($wikipages);
	return $backups;
}


function print_edithtml_for_wikipage($page) {
	$page_c = text_from_wikipage($page);
?>
	<form action="post.php" method="POST">
		<textarea name="texts" style="width: 100%; height:400px" class="input" rows=25 cols=80><?php echo $page_c ?></textarea><br />
		<input type="hidden" name="page" value="<?php echo "$page" ?>" />
		User Name (shown in <a href="<?php echo link_to_wikipage("RecentChanges")?>, should be a <?php echo link_to_wikipage('WikiWord') ?>): <input type="text" name="username" value="<?php echo $_COOKIE['username'] ?>" class="textinput" />
	 	<select name="restore" class="input"><option value="" selected>Restore from backup...</option>
<?php
		foreach (backups_of_wikipage($page) as $backup) {
			echo '<option>' . $backup . '</option>';
		}
?>
		</select><br />
		<input type="hidden" name="crc" value="<?php echo crc32($page_c) ?>" />
		<input type="submit" value="Submit Changes" class="submitbutton" />
	</form>
<?php
}

function url_of_wikipage($page) {
	return 'wiki.php?page=' . $page;
}

function link_to_wikipage($page) {
	return '<a href="' . url_of_wikipage($page) . '">' . $page . '</a>';
}

function path_of_wikipage($page) {
	$options = parse_file("options");
	return wikipage_root() . str_replace('..','.',$page);
}


function text_from_wikipage($page) {
	return file_get_contents(path_of_wikipage($page));
}

function replace_text_with_html_using_regexfile($wikipage, $filepath) {
	$page = $wikipage;
	$regex = fopen($filepath, "r");
	while(!feof($regex)) {
		$conversion = explode(" >>>>> ",fgets($regex,1024));
		$conversion[1] = str_replace("\n","",$conversion[1]);
		while (@ereg($conversion[0], $page, $regs)) {
			$output = $conversion[1];
			for ($i=0; $i<count($regs); $i++) {
				$output = str_replace('$' . strval($i),$regs[$i],$output);
			}
			$page = str_replace($regs[0], $output, $page);
		}
	}
	return $page;
}
?>
