<?php
$WIKI_VERSION = 1.52;

include_once("include/general.php");
include_once("include/special.php");
include_once("include/history.php");
include_once("include/setup.php");
include_once("include/wiki.php");

$options = parse_file("options");

if (isset($_GET['viewcode']) && $options['ShowCode']) {
	Header("Content-type: text/plain");
	echo file_get_contents(ltrim($_GET['viewcode'],"/."));
} else {

$history_index = $_GET["historyindex"];
if (!isset($_GET["historyindex"])) {
	$history_index = -1;
}

set_history(current_page(), $history_index);

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Pragma" content="no-cache" />
		<meta http-equiv="Content-Type" content="text/html; charset=windows-1251" />
		<meta http-equiv="Expires" content="-1" />
		<link href="<?php echo css_path() ?>" rel="stylesheet" type="text/css" />
		<link href="<?php echo $options['IconPath'] ?>" rel="icon" type="image/gif" />

<?php
	if (current_page() !== FALSE) {
		echo "<title>" . current_page() . "</title>";
	} else {
		echo "<title>No Page Selected</title>";
	}
?>
	</head>
	<body>
<?php
	if ($options['ShowTopTitlebar']) {
		echo "<div class=\"titlebar\">\n";
		print_titlebar();
		echo "</div>\n";
	}
	echo "<div id=\"content\">\n";
	if (!isset($_GET['edit']) && !isset($_GET['printversion']) && (!isset($_COOKIE['showhistory']) || $_COOKIE['showhistory'] == "1")) {
		print_history($history_index, " > ");
	}
	if (current_page() === FALSE || current_page() === "") {
		if (isset($_GET['printversion'])) {
			echo "$WIKI_VERSION";
		} else {
			echo "This page has no content, and cannot be edited... The real wiki begins at the " . link_to_wikipage($options['StartingPage']); 
			redirect(url_of_wikipage($options['StartingPage']));
		}
	} else {
	echo "<br /><h1>" . current_page() . "</h1>";
	if (isset($_GET['edit'])) {
		print_edithtml_for_wikipage(current_page());
	} else {
		if (isset($_GET['viewdiff']) && $options['EnableDiff']) {
			print_diff_for_wikipage(current_page());
		} else {
			$page = text_from_wikipage(current_page());
			if ($page[0]=='|') {
				do_special(substr($page,1));
			} else {
				if ($page == "") {
?>
			No definition for <?php echo current_page() ?>.  Please <a href="<?php echo url_of_wikipage(current_page()) ?>&amp;edit=1">define it here</a>.
<?php
				} else {
					echo ereg_replace("\n.?\n",'<br /><br />',replace_text_with_html_using_regexfile($page, "conversionrules.txt"));
				}
			}
		}
	}
	if ($options['EnableDiff']) {
		echo '<br /><br /><span style="font-size: x-small;"><a href="wiki.php?viewdiff=1&amp;page=' . current_page() . '">View diff from last edit...</a></span>';
	}
	if ($_COOKIE['quickchanges'] != 0) {
		echo '<hr />QuickChanges: ';
		$recentchanges = recent_changes(intval($_COOKIE['quickchanges']));
		foreach ($recentchanges as $change) {
			echo "<a href=\"wiki.php?page=$change\">$change</a> | ";
		}
	}
	}
	echo "	</div>\n";
	if ($options['ShowBottomTitlebar']) {
		echo "<div class=\"titlebar\">\n";
		print_titlebar();
		echo "</div>\n";
	}
	echo "	</body>\n";
	echo "</html>";
}
?>