<?php
// Contributed by Jose Nazario
// jose@monkey.org
// Modifications made by Ian Henderson.
// See 'COPYING' for more information.

include_once("include/general.php");
include_once("include/special.php");
include_once("include/history.php");
include_once("include/setup.php");
include_once("include/wiki.php");

$options = parse_file("options");

Header("Content-type: text/rss");

echo "<?xml version=\"1.0\" encoding=\"windows-1251\" ?>\n";
?>
<rss version="2.0"
	xmlns:dc="http://purl.org/dc/elements/1.1/"
	xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
	xmlns:admin="http://webns.net/mvcb/"
	xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
	xmlns:content="http://purl.org/rss/1.0/modules/content/"
	xmlns:cc="http://web.resource.org/cc/">
	<channel>
		<title><?php echo $options['Title'] ?></title>
		<link><?php echo $options['URL'] ?></link>
		<description><?php echo $options['Description'] ?></description>
		<dc:language>en-us</dc:language>
		<dc:creator><?php echo $options['Creator'] ?></dc:creator>
		<dc:rights><?php echo $options['Copyright'] ?></dc:rights>
		<dc:date><?php echo date('Y-m-d\TH:iO') ?></dc:date>
		<admin:generatorAgent rdf:resource="http://www.php.net/" />
		<admin:errorReportsTo rdf:resource="mailto:<?php echo $options['E-Mail'] ?>"/>
		<sy:updatePeriod>hourly</sy:updatePeriod>
		<sy:updateFrequency>1</sy:updateFrequency>
		<sy:updateBase>2000-01-01T12:00+0000</sy:updateBase>

<?php 
	$recents = recent_changes($options['NumberOfHeadlines']);
	foreach ($recents as $page) {
		$filedate = filemtime("wiki_pages/" . $page);
		echo "		<item>\n";
		echo "		<dc:date>" . date("Y-m-d\TH:iO", $filedate) . "</dc:date>\n";
		echo "		<title>$page</title>\n";
		echo "		<link>" . $options['URL'] . url_of_wikipage($page) . "</link>\n";
		$pagetext = text_from_wikipage($page);
		echo "		<content:encoded><![CDATA[";
		echo ereg_replace("\n.?\n",'<br /><br />',replace_text_with_html_using_regexfile($pagetext, "conversionrules.txt"));
		echo "]]></content:encoded>\n";
		echo "		</item>\n";
	}
	clearstatcache();
?>

	</channel>
</rss>